/**
 * \file
 * Functions to hexen-/decode a given piece of binary data.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_HEXENCODE_H__
#define __TR_HEXENCODE_H__

void   TR_hexencode(char *, const char *, size_t);
size_t TR_hexdecode(char *, size_t);

/**
 * Decode an url encoded string. This expects a valid url
 * encoded string and it size as arguments, else the behaviour
 * of this function is undefined.
 * This function modifies the data in buffer. No copy is made.
 * The reason for this is only performance.
 */
size_t TR_urldecode(char *, size_t);

#endif // __TR_HEXENCODE_H__

// vim: set ft=c ts=4 sw=4:
